
#############################################
# Aufg 8.1
#############################################

num_evals = 0
make_ellipsoid_function <- function(a) {
    return(function(x) {
        num_variables = length(x)
        result = 0.0
        for(i in 1:num_variables) {
            exponent = (i - 1) / (num_variables - 1)
            result = result + a ** exponent * x[i] ** 2
        }
        stopifnot(result >= 1e-5)
        num_evals <<- num_evals + 1
        return(result)
    })
}




#############################################
# Aufg 8.2
#############################################

num_points = 100
budget = 5 * (num_points ** 2)
evaluation_counter = 0
best_obj = Inf
best_sol = NULL


# zu minimierende Zielfunktion
objFunction <- function(lhd_matrix) {
    stopifnot(evaluation_counter < budget)
    dim = ncol(lhd_matrix)
    obj_value = sum(1 / (dist(lhd_matrix) ** (dim + 1)))
    if(obj_value < best_obj) {
        best_obj <<- obj_value
        best_sol <<- lhd_matrix
    }
    evaluation_counter <<- evaluation_counter + 1
    return(obj_value)
}


# zufaelliges LHD zur Initialisierung
randomLHD <- function(dimension, numberPoints) {
    lhd = matrix(nrow=numberPoints, ncol=dimension)
    for (i in 1:dimension) {
        lhd[,i] = sample(1:numberPoints)
    }
    return(lhd)
}


